Index: /trunk/sources/HeuristicLab.sln
===================================================================
--- /trunk/sources/HeuristicLab.sln	(revision 2440)
+++ /trunk/sources/HeuristicLab.sln	(revision 2441)
@@ -24,6 +24,4 @@
 Project("{FAE04EC0-301F-11D3-BF4B-00C04F79EFBC}") = "HeuristicLab.BitVector-3.2", "HeuristicLab.BitVector\3.2\HeuristicLab.BitVector-3.2.csproj", "{6D9564BB-956D-4808-8F92-AA7F776F90A5}"
 EndProject
-Project("{FAE04EC0-301F-11D3-BF4B-00C04F79EFBC}") = "HeuristicLab.CEDMA.Charting-3.3", "HeuristicLab.CEDMA.Charting\3.3\HeuristicLab.CEDMA.Charting-3.3.csproj", "{1BF17271-5350-476A-8F6D-FC74FA3E82CA}"
-EndProject
 Project("{FAE04EC0-301F-11D3-BF4B-00C04F79EFBC}") = "HeuristicLab.CEDMA.Server-3.3", "HeuristicLab.CEDMA.Server\3.3\HeuristicLab.CEDMA.Server-3.3.csproj", "{F05D261A-4F7D-46C9-AB9C-21FD4566D719}"
 EndProject
@@ -245,6 +243,4 @@
 EndProject
 Project("{FAE04EC0-301F-11D3-BF4B-00C04F79EFBC}") = "HeuristicLab.Common.Resources-3.2", "HeuristicLab.Common.Resources\3.2\HeuristicLab.Common.Resources-3.2.csproj", "{0E27A536-1C4A-4624-A65E-DC4F4F23E3E1}"
-EndProject
-Project("{FAE04EC0-301F-11D3-BF4B-00C04F79EFBC}") = "HeuristicLab.SparseMatrix-3.2", "HeuristicLab.SparseMatrix\3.2\HeuristicLab.SparseMatrix-3.2.csproj", "{1263BB36-1F20-4960-A5CB-530746DBAD77}"
 EndProject
 Project("{FAE04EC0-301F-11D3-BF4B-00C04F79EFBC}") = "HeuristicLab.Common-3.2", "HeuristicLab.Common\3.2\HeuristicLab.Common-3.2.csproj", "{1FC004FC-59AF-4249-B1B6-FF25873A20E4}"
@@ -498,38 +494,4 @@
 		{6D9564BB-956D-4808-8F92-AA7F776F90A5}.Visualization Debug|x86.ActiveCfg = Debug|x86
 		{6D9564BB-956D-4808-8F92-AA7F776F90A5}.Visualization Debug|x86.Build.0 = Debug|x86
-		{1BF17271-5350-476A-8F6D-FC74FA3E82CA}.CEDMA Debug|Any CPU.ActiveCfg = Debug|Any CPU
-		{1BF17271-5350-476A-8F6D-FC74FA3E82CA}.CEDMA Debug|Any CPU.Build.0 = Debug|Any CPU
-		{1BF17271-5350-476A-8F6D-FC74FA3E82CA}.CEDMA Debug|x64.ActiveCfg = Debug|x64
-		{1BF17271-5350-476A-8F6D-FC74FA3E82CA}.CEDMA Debug|x64.Build.0 = Debug|x64
-		{1BF17271-5350-476A-8F6D-FC74FA3E82CA}.CEDMA Debug|x86.ActiveCfg = Debug|x86
-		{1BF17271-5350-476A-8F6D-FC74FA3E82CA}.CEDMA Debug|x86.Build.0 = Debug|x86
-		{1BF17271-5350-476A-8F6D-FC74FA3E82CA}.Debug|Any CPU.ActiveCfg = Debug|Any CPU
-		{1BF17271-5350-476A-8F6D-FC74FA3E82CA}.Debug|Any CPU.Build.0 = Debug|Any CPU
-		{1BF17271-5350-476A-8F6D-FC74FA3E82CA}.Debug|x64.ActiveCfg = Debug|x64
-		{1BF17271-5350-476A-8F6D-FC74FA3E82CA}.Debug|x64.Build.0 = Debug|x64
-		{1BF17271-5350-476A-8F6D-FC74FA3E82CA}.Debug|x86.ActiveCfg = Debug|x86
-		{1BF17271-5350-476A-8F6D-FC74FA3E82CA}.Debug|x86.Build.0 = Debug|x86
-		{1BF17271-5350-476A-8F6D-FC74FA3E82CA}.Modeling Debug|Any CPU.ActiveCfg = Debug|Any CPU
-		{1BF17271-5350-476A-8F6D-FC74FA3E82CA}.Modeling Debug|Any CPU.Build.0 = Debug|Any CPU
-		{1BF17271-5350-476A-8F6D-FC74FA3E82CA}.Modeling Debug|x64.ActiveCfg = Debug|x64
-		{1BF17271-5350-476A-8F6D-FC74FA3E82CA}.Modeling Debug|x86.ActiveCfg = Debug|x86
-		{1BF17271-5350-476A-8F6D-FC74FA3E82CA}.Release|Any CPU.ActiveCfg = Release|Any CPU
-		{1BF17271-5350-476A-8F6D-FC74FA3E82CA}.Release|Any CPU.Build.0 = Release|Any CPU
-		{1BF17271-5350-476A-8F6D-FC74FA3E82CA}.Release|x64.ActiveCfg = Release|x64
-		{1BF17271-5350-476A-8F6D-FC74FA3E82CA}.Release|x64.Build.0 = Release|x64
-		{1BF17271-5350-476A-8F6D-FC74FA3E82CA}.Release|x86.ActiveCfg = Release|x86
-		{1BF17271-5350-476A-8F6D-FC74FA3E82CA}.Release|x86.Build.0 = Release|x86
-		{1BF17271-5350-476A-8F6D-FC74FA3E82CA}.v3.2 Debug|Any CPU.ActiveCfg = Debug|Any CPU
-		{1BF17271-5350-476A-8F6D-FC74FA3E82CA}.v3.2 Debug|Any CPU.Build.0 = Debug|Any CPU
-		{1BF17271-5350-476A-8F6D-FC74FA3E82CA}.v3.2 Debug|x64.ActiveCfg = Debug|x64
-		{1BF17271-5350-476A-8F6D-FC74FA3E82CA}.v3.2 Debug|x64.Build.0 = Debug|x64
-		{1BF17271-5350-476A-8F6D-FC74FA3E82CA}.v3.2 Debug|x86.ActiveCfg = Debug|x86
-		{1BF17271-5350-476A-8F6D-FC74FA3E82CA}.v3.2 Debug|x86.Build.0 = Debug|x86
-		{1BF17271-5350-476A-8F6D-FC74FA3E82CA}.Visualization Debug|Any CPU.ActiveCfg = Debug|Any CPU
-		{1BF17271-5350-476A-8F6D-FC74FA3E82CA}.Visualization Debug|Any CPU.Build.0 = Debug|Any CPU
-		{1BF17271-5350-476A-8F6D-FC74FA3E82CA}.Visualization Debug|x64.ActiveCfg = Debug|x64
-		{1BF17271-5350-476A-8F6D-FC74FA3E82CA}.Visualization Debug|x64.Build.0 = Debug|x64
-		{1BF17271-5350-476A-8F6D-FC74FA3E82CA}.Visualization Debug|x86.ActiveCfg = Debug|x86
-		{1BF17271-5350-476A-8F6D-FC74FA3E82CA}.Visualization Debug|x86.Build.0 = Debug|x86
 		{F05D261A-4F7D-46C9-AB9C-21FD4566D719}.CEDMA Debug|Any CPU.ActiveCfg = Debug|Any CPU
 		{F05D261A-4F7D-46C9-AB9C-21FD4566D719}.CEDMA Debug|Any CPU.Build.0 = Debug|Any CPU
@@ -3941,32 +3903,4 @@
 		{0E27A536-1C4A-4624-A65E-DC4F4F23E3E1}.Visualization Debug|x64.ActiveCfg = Debug|Any CPU
 		{0E27A536-1C4A-4624-A65E-DC4F4F23E3E1}.Visualization Debug|x86.ActiveCfg = Debug|Any CPU
-		{1263BB36-1F20-4960-A5CB-530746DBAD77}.CEDMA Debug|Any CPU.ActiveCfg = Debug|Any CPU
-		{1263BB36-1F20-4960-A5CB-530746DBAD77}.CEDMA Debug|Any CPU.Build.0 = Debug|Any CPU
-		{1263BB36-1F20-4960-A5CB-530746DBAD77}.CEDMA Debug|x64.ActiveCfg = Debug|Any CPU
-		{1263BB36-1F20-4960-A5CB-530746DBAD77}.CEDMA Debug|x86.ActiveCfg = Debug|x86
-		{1263BB36-1F20-4960-A5CB-530746DBAD77}.Debug|Any CPU.ActiveCfg = Debug|Any CPU
-		{1263BB36-1F20-4960-A5CB-530746DBAD77}.Debug|Any CPU.Build.0 = Debug|Any CPU
-		{1263BB36-1F20-4960-A5CB-530746DBAD77}.Debug|x64.ActiveCfg = Debug|x64
-		{1263BB36-1F20-4960-A5CB-530746DBAD77}.Debug|x64.Build.0 = Debug|x64
-		{1263BB36-1F20-4960-A5CB-530746DBAD77}.Debug|x86.ActiveCfg = Debug|x86
-		{1263BB36-1F20-4960-A5CB-530746DBAD77}.Debug|x86.Build.0 = Debug|x86
-		{1263BB36-1F20-4960-A5CB-530746DBAD77}.Modeling Debug|Any CPU.ActiveCfg = Debug|Any CPU
-		{1263BB36-1F20-4960-A5CB-530746DBAD77}.Modeling Debug|Any CPU.Build.0 = Debug|Any CPU
-		{1263BB36-1F20-4960-A5CB-530746DBAD77}.Modeling Debug|x64.ActiveCfg = Debug|Any CPU
-		{1263BB36-1F20-4960-A5CB-530746DBAD77}.Modeling Debug|x86.ActiveCfg = Debug|x86
-		{1263BB36-1F20-4960-A5CB-530746DBAD77}.Release|Any CPU.ActiveCfg = Release|Any CPU
-		{1263BB36-1F20-4960-A5CB-530746DBAD77}.Release|Any CPU.Build.0 = Release|Any CPU
-		{1263BB36-1F20-4960-A5CB-530746DBAD77}.Release|x64.ActiveCfg = Release|x64
-		{1263BB36-1F20-4960-A5CB-530746DBAD77}.Release|x64.Build.0 = Release|x64
-		{1263BB36-1F20-4960-A5CB-530746DBAD77}.Release|x86.ActiveCfg = Release|x86
-		{1263BB36-1F20-4960-A5CB-530746DBAD77}.Release|x86.Build.0 = Release|x86
-		{1263BB36-1F20-4960-A5CB-530746DBAD77}.v3.2 Debug|Any CPU.ActiveCfg = Debug|Any CPU
-		{1263BB36-1F20-4960-A5CB-530746DBAD77}.v3.2 Debug|Any CPU.Build.0 = Debug|Any CPU
-		{1263BB36-1F20-4960-A5CB-530746DBAD77}.v3.2 Debug|x64.ActiveCfg = Debug|Any CPU
-		{1263BB36-1F20-4960-A5CB-530746DBAD77}.v3.2 Debug|x86.ActiveCfg = Debug|Any CPU
-		{1263BB36-1F20-4960-A5CB-530746DBAD77}.Visualization Debug|Any CPU.ActiveCfg = Debug|Any CPU
-		{1263BB36-1F20-4960-A5CB-530746DBAD77}.Visualization Debug|Any CPU.Build.0 = Debug|Any CPU
-		{1263BB36-1F20-4960-A5CB-530746DBAD77}.Visualization Debug|x64.ActiveCfg = Debug|Any CPU
-		{1263BB36-1F20-4960-A5CB-530746DBAD77}.Visualization Debug|x86.ActiveCfg = Debug|Any CPU
 		{1FC004FC-59AF-4249-B1B6-FF25873A20E4}.CEDMA Debug|Any CPU.ActiveCfg = Debug|Any CPU
 		{1FC004FC-59AF-4249-B1B6-FF25873A20E4}.CEDMA Debug|Any CPU.Build.0 = Debug|Any CPU
@@ -4102,5 +4036,4 @@
 		{F43B59AB-2B8C-4570-BC1E-15592086517C} = {410732DB-725A-4824-896B-C298978343C0}
 		{6D9564BB-956D-4808-8F92-AA7F776F90A5} = {410732DB-725A-4824-896B-C298978343C0}
-		{1BF17271-5350-476A-8F6D-FC74FA3E82CA} = {410732DB-725A-4824-896B-C298978343C0}
 		{F05D261A-4F7D-46C9-AB9C-21FD4566D719} = {410732DB-725A-4824-896B-C298978343C0}
 		{B462D3CC-8866-42F0-9832-AD0967613B72} = {410732DB-725A-4824-896B-C298978343C0}
@@ -4185,5 +4118,4 @@
 		{569E430B-B4CE-4B94-A44E-6246B6E4E3BC} = {410732DB-725A-4824-896B-C298978343C0}
 		{0E27A536-1C4A-4624-A65E-DC4F4F23E3E1} = {410732DB-725A-4824-896B-C298978343C0}
-		{1263BB36-1F20-4960-A5CB-530746DBAD77} = {410732DB-725A-4824-896B-C298978343C0}
 		{1FC004FC-59AF-4249-B1B6-FF25873A20E4} = {410732DB-725A-4824-896B-C298978343C0}
 		{3127719F-110E-4558-8845-98559DBB422D} = {410732DB-725A-4824-896B-C298978343C0}
Index: /trunk/sources/HeuristicLab/CopyAssemblies.cmd
===================================================================
--- /trunk/sources/HeuristicLab/CopyAssemblies.cmd	(revision 2440)
+++ /trunk/sources/HeuristicLab/CopyAssemblies.cmd	(revision 2441)
@@ -16,5 +16,4 @@
 copy "%SolutionDir%\HeuristicLab.BitVector\3.2\%Outdir%\HeuristicLab.BitVector-3.2.dll" .\plugins
 copy "%SolutionDir%\HeuristicLab.BackgroundProcessing\3.2\%Outdir%\HeuristicLab.BackgroundProcessing-3.2.dll" .\plugins
-copy "%SolutionDir%\HeuristicLab.CEDMA.Charting\3.3\%Outdir%\HeuristicLab.CEDMA.Charting-3.3.dll" .\plugins
 copy "%SolutionDir%\HeuristicLab.CEDMA.Server\3.3\%Outdir%\HeuristicLab.CEDMA.Server-3.3.dll" .\plugins
 copy "%SolutionDir%\HeuristicLab.Charting\3.2\%Outdir%\HeuristicLab.Charting-3.2.dll" .\plugins
@@ -112,5 +111,4 @@
 copy "%SolutionDir%\HeuristicLab.FixedOperators\3.2\%Outdir%\HeuristicLab.FixedOperators-3.2.dll" .\plugins
 copy "%SolutionDir%\HeuristicLab.SimOpt\3.2\%Outdir%\HeuristicLab.SimOpt-3.2.dll" .\plugins
-copy "%SolutionDir%\HeuristicLab.SparseMatrix\3.2\%Outdir%\HeuristicLab.SparseMatrix-3.2.dll" .\plugins
 copy "%SolutionDir%\HeuristicLab.SQLite\3.2\%Outdir%\HeuristicLab.SQLite-3.2.dll" .\plugins
 copy "%SolutionDir%\HeuristicLab.SQLite\3.2\SQLite License.txt" .\plugins