Index: trunk/sources/HeuristicLab.MainForm.Test/3.2/MenuItems/ExitToolStripMenuItem.cs
===================================================================
--- trunk/sources/HeuristicLab.MainForm.Test/3.2/MenuItems/ExitToolStripMenuItem.cs	(revision 2256)
+++ trunk/sources/HeuristicLab.MainForm.Test/3.2/MenuItems/ExitToolStripMenuItem.cs	(revision 2458)
@@ -5,15 +5,15 @@
 using System.Windows.Forms;
 
-using HeuristicLab.MainForm;
+using HeuristicLab.MainForm.WindowsForms;
 using HeuristicLab.Common.Resources;
 
 namespace HeuristicLab.MainForm.Test {
-  public class CloseToolStripMenuItem : ToolStripMenuItemBase, ITestUserInterfaceItemProvider {
+  public class CloseToolStripMenuItem : HeuristicLab.MainForm.WindowsForms.MenuItemBase, ITestUserInterfaceItemProvider {
     public override string Name {
       get { return "Exit"; }
     }
 
-    public override string Structure {
-      get { return "File"; }
+    public override IEnumerable<string> Structure {
+      get { return new string[] { "File" }; }
     }
 
@@ -22,6 +22,6 @@
     }
 
-    public override void Execute(IMainForm mainform) {
-      mainform.Close();
+    public override void Execute() {
+      MainFormManager.MainForm.Close();
     }
   }
Index: trunk/sources/HeuristicLab.MainForm.Test/3.2/MenuItems/FileToolStripMenuItem.cs
===================================================================
--- trunk/sources/HeuristicLab.MainForm.Test/3.2/MenuItems/FileToolStripMenuItem.cs	(revision 2256)
+++ 	(revision )
@@ -1,19 +1,0 @@
-﻿using System;
-using System.Collections.Generic;
-using System.Linq;
-using System.Text;
-
-namespace HeuristicLab.MainForm.Test.MenuItems {
-  public class FileToolStripMenuItem : ToolStripMenuItemBase, ITestUserInterfaceItemProvider{
-    public override int Position {
-      get { return 1000; }
-    }
-
-    public override string Name {
-      get { return "File"; }
-    }
-
-    public override void Execute(IMainForm mainform) {      
-    }
-  }
-}
Index: trunk/sources/HeuristicLab.MainForm.Test/3.2/MenuItems/NewEditorToolStripMenuItem.cs
===================================================================
--- trunk/sources/HeuristicLab.MainForm.Test/3.2/MenuItems/NewEditorToolStripMenuItem.cs	(revision 2256)
+++ trunk/sources/HeuristicLab.MainForm.Test/3.2/MenuItems/NewEditorToolStripMenuItem.cs	(revision 2458)
@@ -5,15 +5,15 @@
 using System.Windows.Forms;
 
-using HeuristicLab.MainForm;
 using HeuristicLab.Common.Resources;
+using HeuristicLab.MainForm.WindowsForms;
 
 namespace HeuristicLab.MainForm.Test {
-  public class NewEditorToolStripMenuItem : ToolStripMenuItemBase, ITestUserInterfaceItemProvider {
+  public class NewEditorToolStripMenuItem : HeuristicLab.MainForm.WindowsForms.MenuItemBase, ITestUserInterfaceItemProvider {
     public override string Name {
       get { return "Editor"; }
     }
 
-    public override string Structure {
-      get { return "File/New"; }
+    public override IEnumerable<string> Structure {
+      get { return "File/New".Split('/'); }
     }
 
@@ -22,6 +22,6 @@
     }
 
-    public override void Execute(IMainForm mainform) {
-      new NewEditorAction().Execute(mainform);
+    public override void Execute() {
+      NewEditorAction.Execute(MainFormManager.MainForm);
     }
   }
Index: trunk/sources/HeuristicLab.MainForm.Test/3.2/MenuItems/NewFormToolStripMenuItem.cs
===================================================================
--- trunk/sources/HeuristicLab.MainForm.Test/3.2/MenuItems/NewFormToolStripMenuItem.cs	(revision 2256)
+++ trunk/sources/HeuristicLab.MainForm.Test/3.2/MenuItems/NewFormToolStripMenuItem.cs	(revision 2458)
@@ -5,23 +5,24 @@
 using System.Windows.Forms;
 
-using HeuristicLab.MainForm;
+using HeuristicLab.MainForm.WindowsForms;
 using HeuristicLab.Common.Resources;
 
 namespace HeuristicLab.MainForm.Test {
-  public class NewFormToolStripMenuItem : ToolStripMenuItemBase, ITestUserInterfaceItemProvider {
+  public class NewFormToolStripMenuItem : HeuristicLab.MainForm.WindowsForms.MenuItemBase, ITestUserInterfaceItemProvider {
     public override string Name {
       get { return "Form"; }
     }
 
-    public override string Structure {
-      get { return "File/New"; }
+    public override IEnumerable<string> Structure {
+      get { return "File/New".Split('/'); }
     }
 
     public override int Position {
       get { return 1110; }
+    
     }
 
-    public override void Execute(IMainForm mainform) {
-      new NewFormAction().Execute(mainform);
+    public override void Execute() {
+      new NewFormAction().Execute(MainFormManager.MainForm);
     }
   }
Index: trunk/sources/HeuristicLab.MainForm.Test/3.2/MenuItems/NewToolStripMenuItem.cs
===================================================================
--- trunk/sources/HeuristicLab.MainForm.Test/3.2/MenuItems/NewToolStripMenuItem.cs	(revision 2256)
+++ 	(revision )
@@ -1,31 +1,0 @@
-﻿using System;
-using System.Collections.Generic;
-using System.Linq;
-using System.Text;
-using System.Windows.Forms;
-
-using HeuristicLab.MainForm;
-using HeuristicLab.Common.Resources;
-
-namespace HeuristicLab.MainForm.Test {
-  public class NewToolStripMenuItem : ToolStripMenuItemBase, ITestUserInterfaceItemProvider {
-    public override string Name {
-      get { return "New"; }
-    }
-
-    public override string Structure {
-      get { return "File"; }
-    }
-
-    public override int Position {
-      get { return 1100; }
-    }
-
-    public override System.Drawing.Image Image {
-      get { return Resources.NewIcon; }
-    }
-
-    public override void Execute(IMainForm mainform) {
-    }
-  }
-}
Index: trunk/sources/HeuristicLab.MainForm.Test/3.2/MenuItems/OpenToolStripMenuItem.cs
===================================================================
--- trunk/sources/HeuristicLab.MainForm.Test/3.2/MenuItems/OpenToolStripMenuItem.cs	(revision 2256)
+++ trunk/sources/HeuristicLab.MainForm.Test/3.2/MenuItems/OpenToolStripMenuItem.cs	(revision 2458)
@@ -4,15 +4,15 @@
 using System.Text;
 using System.Windows.Forms;
-using HeuristicLab.MainForm;
+using HeuristicLab.MainForm.WindowsForms;
 using HeuristicLab.Common.Resources;
 
 namespace HeuristicLab.MainForm.Test {
-  public class OpenToolStripMenuItem : ToolStripMenuItemBase, ITestUserInterfaceItemProvider {
+  public class OpenToolStripMenuItem : HeuristicLab.MainForm.WindowsForms.MenuItemBase, ITestUserInterfaceItemProvider {
     public override string Name {
       get { return "Open"; }
-    }   
+    }
 
-    public override string Structure {
-      get { return "File"; }
+    public override IEnumerable<string> Structure {
+      get { return new string[] { "File" }; }
     }
 
@@ -29,6 +29,6 @@
     }
 
-    public override void Execute(IMainForm mainform) {
-      new OpenAction().Execute(mainform);
+    public override void Execute() {
+      new OpenAction().Execute(MainFormManager.MainForm);
     }
   }
Index: trunk/sources/HeuristicLab.MainForm.Test/3.2/MenuItems/SaveToolStripMenuItem.cs
===================================================================
--- trunk/sources/HeuristicLab.MainForm.Test/3.2/MenuItems/SaveToolStripMenuItem.cs	(revision 2256)
+++ trunk/sources/HeuristicLab.MainForm.Test/3.2/MenuItems/SaveToolStripMenuItem.cs	(revision 2458)
@@ -5,15 +5,15 @@
 using System.Windows.Forms;
 
-using HeuristicLab.MainForm;
+using HeuristicLab.MainForm.WindowsForms;
 using HeuristicLab.Common.Resources;
 
 namespace HeuristicLab.MainForm.Test {
-  public class SaveToolStripMenuItem : ToolStripMenuItemBase, ITestUserInterfaceItemProvider {
+  public class SaveToolStripMenuItem : HeuristicLab.MainForm.WindowsForms.MenuItemBase, ITestUserInterfaceItemProvider {
     public override string Name {
       get { return "Save"; }
     }
 
-    public override string Structure {
-      get { return "File"; }
+    public override IEnumerable<string> Structure {
+      get { return new string[]{"File"}; }
     }
 
@@ -30,6 +30,6 @@
     }
 
-    public override void Execute(IMainForm mainform) {
-      new SaveAction().Execute(mainform);
+    public override void Execute() {
+      new SaveAction().Execute(MainFormManager.MainForm);
     }
   }